--------------------------------------------------
-- variables
local icolor = 1
local jcolor = 1
local hudW_bg_color = SKINCOLOR_BLACK

local hudW_info_trans = V_HUDTRANS
local hudW_weather_movY = 0

local hudW_timer_color = 0
local hudW_current_color = 0

local hudW_splitscn_place = 0
local hudW_splitscn_text = 0

local weatherORB = 1;

addHook("ThinkFrame", function()
if weathermod.running -- main toggle

    -- weather name shaking effect
    if weathermod.delay ~= 0 and not weathermod.active
        if leveltime%3 == 2 hudW_weather_movY = 1
        elseif leveltime%3 == 1 hudW_weather_movY = -1
        else hudW_weather_movY = 0
        end
    end

    -- Orb animation
    if leveltime > 6*TICRATE + (3*TICRATE/4) and weathermod.active == true
        if leveltime%3 == 1 weatherORB = $ + 1 end
    end
    if weathermod.delay > 0
        if leveltime%2 == 1 weatherORB = $ - 1 end
    end
    -- make loops with the number
    if weatherORB > 6 weatherORB = 1;
    elseif weatherORB < 1 weatherORB = 6;
    end

    -- color effect when weather is gonna start
    if leveltime > 6*TICRATE + (3*TICRATE/4) and weathermod.active == false and weathermod.timerW <= cv_weather_decrement.value*50
        if leveltime%6 == 1 and hudW_bg_color ~= 1
            hudW_bg_color = $ - 1
        end
    else hudW_bg_color = SKINCOLOR_BLACK
    end

    -- color cycle effect
    if weathermod.active
		if leveltime%4 == 3
			icolor = $ + jcolor
			if icolor >= 4 jcolor = -1 end
			if icolor <= 0 jcolor = 1 end
		end
        hudW_bg_color = weathermod.current.color + icolor
        hudW_timer_color = V_ORANGEMAP
    end

    -- hud effect on weather active (end)
    if weathermod.active and weathermod.timerW >= cv_weather_maxtime.value-(cv_weather_increment.value*105) and weathermod.forceActive == false
        if leveltime%6 == 1 or leveltime%6 == 0 hudW_timer_color = 0 end -- two frames blinking
    end

    if weathermod.active == false hudW_timer_color = 0 end

    -- blinking effect based on 3 frames
    if weathermod.timerW <= 0+(cv_weather_increment.value*15)  
        if leveltime%3 == 2 hudW_info_trans = V_HUDTRANSHALF
        elseif leveltime%3 == 1 hudW_info_trans = V_80TRANS
        else hudW_info_trans = V_HUDTRANS
        end
    else hudW_info_trans = V_HUDTRANS
    end
end
end)

--------------------------------------------------------
-- creates the hud
local function debugtxt(v, player)
    if weathermod.running -- main toggle

    if weathermod.current == nil return end

    -- [night case] night weather
    if weathermod.active == true and weathermod.current.id == 19 and replayplayback == false
        --Display only once in case of splitscreen
        if displayplayers[0] == player
            -- Si ça ne remplit pas sur les résolutions personalisés je nique aqua!
            -- dafuq, scaling at x9000 causes issues on software?
            if (encoremode == true and cv_weathermod_encore.value == 1) or (cv_weathermod_encore.value == 2)
             --v.drawScaled(FRACUNIT*v.width(), 0, FRACUNIT*5000, v.cachePatch("WHNIGH"), V_10TRANS|V_SNAPTOTOP|V_SNAPTOLEFT)
			 v.fadeScreen(31, 9) -- why not use fadescreen?????
            --else v.drawScaled(FRACUNIT*v.width(), 0, FRACUNIT*5000, v.cachePatch("WHNIGH"), V_20TRANS|V_SNAPTOTOP|V_SNAPTOLEFT) end
			else v.fadeScreen(31, 8) end
		end
    end

    -- on 2 players splitscreen, place the hud on center
    if (splitscreen == 1) 
        hudW_splitscn_place = FRACUNIT*200/2-FRACUNIT*21
        hudW_splitscn_text = 200/2-21
    end

    -- top screen weather indication
    if cv_weathermod_visible.value == 1

    v.drawScaled(FRACUNIT*127, -FRACUNIT*3+hudW_splitscn_place, FRACUNIT*4/3, v.cachePatch("WHCURB" + tostring(weatherORB)), V_HUDTRANS|V_SNAPTOTOP, v.getColormap(0, hudW_bg_color)) -- hud bg weather

    -- hud effect on weather active (start)
    if leveltime > 6*TICRATE + (3*TICRATE/4) and weathermod.active and weathermod.timerW <= 0+(cv_weather_increment.value*90) and weathermod.forceActive == false

        if splitscreen == 0 v.drawKartString(320/2-(weathermod.current.centerX*2), 44, "" + weathermod.current.name, hudW_info_trans|V_SNAPTOTOP) end -- show the weather when active
        if (encoremode == true and cv_weathermod_encore.value == 1) or -- [[ENCORE MODE]]
         (cv_weathermod_encore.value == 2) v.drawString(170-(weathermod.current.encore:len()/3), 58+hudW_splitscn_text*3/4, "" + weathermod.current.encore, V_HUDTRANS|V_ALLOWLOWERCASE|V_SNAPTOTOP|V_SKYMAP, "center") -- encore mode desc
        else v.drawString(170-(weathermod.current.desc:len()/3), 58+hudW_splitscn_text*3/4, "" + weathermod.current.desc, V_HUDTRANS|V_ALLOWLOWERCASE|V_SNAPTOTOP|V_PINKMAP, "center") -- description of the weather
        end
    end

    if weathermod.current.id >= 90 hudW_current_color = V_REDMAP
    else hudW_current_color = 0 end
   
    v.drawString(156-weathermod.current.centerX, 8+hudW_weather_movY+hudW_splitscn_text, "" + weathermod.current.name, hudW_current_color|V_HUDTRANS|V_ALLOWLOWERCASE|V_SNAPTOTOP, "thin") -- actual weather
    v.drawString(152, 21+hudW_splitscn_text, weathermod.timerW/100 + "." + (weathermod.timerW/10)%10, hudW_timer_color|V_HUDTRANS|V_SNAPTOTOP, "center") -- timer
    end
    end
end

--hud.disable("time")
-- add the hud to the game
hud.add(debugtxt, "game" )